; Concatinate strings into one output string
concat	LSL	R24		; x2 for word args
	MOV	R30,R24		; Get offset
	CLR	R31		; Zero high
	ADD	R30,R28		; Offset to top arg
	ADC	R31,R29		; ""
	LD	R27,-Z		; X = Output buffer
	LD	R26,-Z		; ""
?1	SUBI	R24,2		; Decrement argument count
	BREQ	?5		; Exit
	MOV	R30,R24		; Get offset
	CLR	R31		; Zero high
	ADD	R30,R28		; Offset to arg
	ADC	R31,R29		; ""
	LD	R25,-Z		; Z = Source pointer
	LD	R30,-Z		; ""
	MOV	R31,R25		; Set high address
	OR	R25,R30		; Special case?
	BREQ	?3		; Handle it
?2	LD	R25,Z+		; Get byte from source
	TST	R25		; At end?
	BREQ	?1		; Yes, get next
	ST	X+,R25		; Write to dest
	RJMP	?2		; Do them all
?3 	SUBI	R24,2		; Reduce argument count
	MOV	R30,R24		; Get offset
	CLR	R31		; Zero high
	ADD	R30,R28		; Offset to arg
	ADC	R31,R29		; ""
	LD	R25,-Z		; Z = source pointer
	LD	R30,-Z		; ""
	MOV	R31,R25		; Set high address
?4	LPM			; Get program code
	TST	R0		; End?
	BREQ	?1		; Get next
	ADIW	Z,1		; Skip to next
	ST	X+,R0		; Write it
	RJMP	?4		; And handle it
?5	ST	X,R24		; Zero it
	RET
