*
* Test file to demonstrate instructions and addresing modes of: AVR
*
L1	EQU	10
L2	EQU	1000
L3	EQU	10000
*
	ADC	R0,R16
	ADD	R1,R17
	ADIW	R24,L1		Standard R25:R25 double add
	ADIW	W,L1		ASMAVR allows 'W','X','Y','Z'
	AND	R2,R18
	ANDI	R19,L1
	ASR	R3
*
	BCLR	5		Also allows 'C','Z','N','V','S','H','T','I'
	BLD	R19,4
X1:	BRBC	1,X2
X2:	BRBS	2,X1
	BRCC	X1
	BRCS	X2
	BREQ	X1
	BRGE	X2
	BRHC	X1
	BRHS	X2
	BRID	X1
	BRIE	X2
	BRLO	X3
	BRLT	X4
	BRMI	X3
	BRNE	X4
	BRPL	X3
	BRSH	X4
	BRTC	X3
	BRTS	X4
	BRVC	X3
	BRVS	X4
X3:	BSET	6
X4:	BST	R6,7
*
	CALL	L3		Call within current CPAGE
	CALL	1,L3		Call within page 1
	CBI	L1,4
	CBR	R17,L1
	CLC
	CLH
	CLI
	CLN
	CLR	R2
	CLS
	CLT
	CLV
	CLZ
	COM	R21
	CP	R6,R16
	CPC	R7,R17
	CPI	R25,L1
	CPSE	R8,R18
*
	DEC	R3
	EOR	R9,R19
	ICALL
	IJMP
	IN	R4,L1
	INC	R5
	JMP	L3		Jump within current CPAGE
	JMP	1,L3		Jump within page 1
*
	LD	R1,X
	LD	R2,X+
	LD	R3,-X
	LD	R4,Y
	LD	R5,Y+
	LD	R6,-Y
	LDD	R7,Y+L1
	LD	R8,Z
	LD	R9,Z+
	LD	R10,-Z
	LDD	R11,Z+L1
	LDI	R20,L1
	LDS	R21,L3
	LPM
	LSL	R6
	LSR	R7
*
	MOV	R28,R8
	MUL	R29,R9
	NEG	R8
	NOP
	OR	R30,R10
	ORI	R31,L1
	OUT	L1,R23
	POP	R4
	PUSH	R24
	RCALL	L2
	RET
	RETI
	RJMP	L2
	ROL	R25
	ROR	R6
*
	SBC	R7,R27
	SBCI	R21,L1
	SBI	L1,6
	SBIC	L1,1
	SBIS	L1,2
	SBIW	R28,L1
	SBR	R19,L1
	SBRC	R13,7
	SBRS	R5,0
	SEC
	SEH
	SEI
	SEN
	SER	R17
	SES
	SET
	SEV
	SEZ
	SLEEP
	ST	X,R1
	ST	X+,R2
	ST	-X,R3
	ST	Y,R4
	ST	Y+,R5
	ST	-Y,R6
	STD	Y+L1,R7
	ST	Z,R8
	ST	Z+,R9
	ST	-Z,R10
	STD	Z+L1,R11
	STS	L3,R29
	SUB	R13,R1
	SUBI	R18,L1
	SWAP	R0
*
	TST	R30
	WDR
