;
; Write "raw" character to serial port: putchr(char c)
;
putchr	LD	R24,Y		; Get character to write
?putchr	SBIS	USR-$20,5	; Transmit empty?
	RJMP	?putchr		; No, wait
	CLR	R25		; Zero high
	OUT	UDR-$20,R24	; Write to uart
	RET
;
; Check for character from the serial port
;
chkchr	SBIC	USR-$20,7	; Skip if no char
	RJMP	?getc1		; Get the character
	SER	R25		; Zero high
	SER	R24		; Zero low
	RET
;
; Read a character from the serial port
;
getchr	SBIS	USR-$20,7	; Receive ready?
	RJMP	getchr		; No, wait
?getc1	CLR	R25		; Zero high
	IN	R24,UDR-$20	; Read data
	RET
