; Return absolute value of operand: int abs(int v)
abs	LDD	R24,Y+0		; Get low operand
	LDD	R25,Y+1		; Get high operand
	TST	R25		; Is it negative
	BRPL	?abs1		; No, it's OK
	COM	R24		; Invert
	COM	R25		; Invert
	ADIW	W,1		; Two's compliment
?abs1	RET
; Return the minimum of two operands: int min(int v1, int v2)
min	LDD	R24,Y+0		; Get low v2
	LDD	R25,Y+1		; Get high v2
	LDD	R22,Y+2		; Get low v1
	LDD	R23,Y+3		; Get high v1
	CP	R24,R22		; Compare low
	CPC	R25,R23		; Compare high
	BRLT	?abs1		; Already have it
?min1	MOV	R24,R22		; Get low value
	MOV	R25,R23		; Get high value
	RET
; Return the maximum of two operands: int max(int v1, int v2)
max	LDD	R24,Y+0		; Get low v2
	LDD	R25,Y+1		; Get high v2
	LDD	R22,Y+2		; Get low v1
	LDD	R23,Y+3		; Get high v1
	CP	R24,R22		; Compare low
	CPC	R25,R23		; Compare high
	BRLT	?min1		; Lower, swap
	RET
; Return the square root of the argument: unsigned sqrt(unsigned v)
sqrt	LDD	R20,Y+0		; Get low argument
	LDD	R21,Y+1		; Get high argment
	SER	R19		; Begin with 255
	CPI	R21,$FE		; Out of range?
	BRSH	?sqrt2		; Early exit
?sqrt1	INC	R19		; Advance
	MOV	R24,R19		; Get value
	CLR	R25		; Zero high
	MOV	R22,R19		; Get value
	CLR	R23		; Zero high
	CALL	?mul		; Perform multiply
	CP	R24,R20		; Test against result
	CPC	R25,R21		; Test against result
	BRLO	?sqrt1		; Go till we get it
?sqrt2	MOV	R24,R19		; Get result
	CLR	R25		; Zero high
	RET
